com.singularsys.jep.misc.functions

## Class Case

- java.lang.Object
- - com.singularsys.jep.functions.PostfixMathCommand
  - - com.singularsys.jep.misc.functions.Case

- All Implemented Interfaces:
    CallbackEvaluationI, PostfixMathCommandI, java.io.Serializable

      public class Case
      extends PostfixMathCommand
      implements CallbackEvaluationI

  A case statement. The argument first argument is evaluated and then checked against the 2nd, 4th, 6th argument if the two are equal then the 3rd, 5th, 7th argument is returned. If no arguments match then the last argument is returned (if the number of args is even) for example `case("c","a",5,"b",6,"c",7,8)` will return 7.
  Author:
    Richard Morris
  See Also:
    `Switch`, Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `Case.NullBehaviour` Action to take if first argument is null.

  - ### Field Summary

    - ### Fields inherited from class com.singularsys.jep.functions.PostfixMathCommand

      `curNumberOfParameters, name, NaN, numberOfParameters`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Case()` Standard constructor with no default value and errors if null if found.
    `Case(Case.NullBehaviour nullBehaviour)` Constructor with defined behaviour for null.
    `Case(java.lang.Object defaultVal)` A case statement with a predefined default value and errors if null if found.
    `Case(java.lang.Object defaultVal, Case.NullBehaviour nullBehaviour)` Case statement with given default value and defined null behaviour.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `checkNumberOfParameters(int n)` Must have at least 3 parameters.
    `java.lang.Object` | `evaluate(Node node, Evaluator pv)` Performs some special evaluation on the node.
    `java.lang.Object` | `getDefaultVal()` The default value, only meaningful if isHasDefault() is true.
    `Case.NullBehaviour` | `getNullBehaviour()` Behaviour when passed zero arguments.
    `boolean` | `isHasDefault()` Whether a default value is set

    - ### Methods inherited from class com.singularsys.jep.functions.PostfixMathCommand

      `asArray, asBool, asDouble, asInt, asLong, asStrictInt, asString, getName, getNumberOfParameters, run, setCurNumberOfParameters, setName, toString, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Case

          public Case()

      Standard constructor with no default value and errors if null if found.

    - #### Case

          public Case(Case.NullBehaviour nullBehaviour)

      Constructor with defined behaviour for null.
      Parameters:
        `nullBehaviour` - action to take if first argument is null
      Since:
        Jep 3.5

    - #### Case

          public Case(java.lang.Object defaultVal)

      A case statement with a predefined default value and errors if null if found.
      Parameters:
        `defaultVal` - The default value to return when no cases match
      Since:
        Jep 3.5

    - #### Case

          public Case(java.lang.Object defaultVal,
                      Case.NullBehaviour nullBehaviour)

      Case statement with given default value and defined null behaviour.
      Parameters:
        `defaultVal` - The default value to return when no cases match
        `nullBehaviour` - action to take if first argument is null
      Since:
        Jep 3.5

  - ### Method Detail

    - #### isHasDefault

          public boolean isHasDefault()

      Whether a default value is set
      Returns:
        true if a default value is set
      Since:
        Jep 3.5

    - #### getDefaultVal

          public java.lang.Object getDefaultVal()

      The default value, only meaningful if isHasDefault() is true.
      Returns:
        the default value used.
      Since:
        Jep 3.5

    - #### getNullBehaviour

          public Case.NullBehaviour getNullBehaviour()

      Behaviour when passed zero arguments.
      Returns:
        code indicating behaviour type
      Since:
        Jep 3.5

    - #### checkNumberOfParameters

          public boolean checkNumberOfParameters(int n)

      Must have at least 3 parameters.
      Specified by:
        `checkNumberOfParameters` in interface `PostfixMathCommandI`
      Overrides:
        `checkNumberOfParameters` in class `PostfixMathCommand`
      Parameters:
        `n` - number of parameters function will be called with.
      Returns:
        false if an illegal number of parameters is supplied, true otherwise.

    - #### evaluate

          public java.lang.Object evaluate(Node node,
                                           Evaluator pv)
                                    throws EvaluationException

      Description copied from interface: `CallbackEvaluationI`
      Performs some special evaluation on the node. This method has the responsibility for evaluating the children of the node and it should generally call

           pv.eval(node.jjtGetChild(i))

      for each child. The SymbolTable is not passed as an argument. This is because it is better practice to get and set variable values by using node.getVar().setValue() rather that through the SymbolTable with requires a hashtable lookup.
      Specified by:
        `evaluate` in interface `CallbackEvaluationI`
      Parameters:
        `node` - The current node
        `pv` - The visitor, can be used evaluate the children
      Returns:
        the value after evaluation. This value will be passed to other functions higher up the node tree. The value can be any type including Double or Vector<Object>
      Throws:
        `EvaluationException` - if the calculation cannot be performed
      See Also:
        `Evaluator`

Copyright © 2018 Singular Systems http://www.singularsys.com/jep